;----------------
;GeorgeController
;----------------
#cs
Program to Control
SONY DSC Conference Cameras via Serial port VISCA protocol.
Kramer 6X6 composite Video Switch
4X4 HDMI Video Switch
EPSON PowerLite 4650 Projector
Control of retractable Screen via a HID interfaced USB controlled Relays
Provides Web Server that allows Macros to be executed remotely by OBS Studio
Web server can be accessed from any browser and provides simplistic web interface.
Replaces Kramer control software so naturely it is named George

Program written in the Free Scripting Langauge AutoIT
For more information on this great tool visit.
https://www.autoitscript.com

Author: Paul Verboom
Date: 2020-07

COM library allows multiple Channels. Channels are selected in individual Modules.
Channels are distinct from COM ports. COM ports are specified in INI file.
Switching COM channels introduces delays so Channel One is left active to minimis delays in Camera control.
Any other module that switch to differnet channel must switch back.
Channel assignments are;
1 - Visca Cammera contol
2 - 4X4 Matrix Switch
3 - 6X6 Krammer VS???
4 - EPSON PowerLite 4650 Projector
5 - EPSON PowerLite 4650 Projector

Revision History
1.0 Initial placed into use
1.1 Added knee speed adjustment (simplified version of logarithmic response) to joystick control
1.2 Fixed numerous bugs, added dead zone to JoyStick
1.3 Added nunge action on pan arrows
	Allowed editing of Macros.
	Reworked macro recording buttons
	Added support of multiple HID relays to allows power control buttons
1.4 Added nunge action to Zoom arrows
1.4.0.2 Removed unrequired group box
List in GUI are type ListBox NOT ListView
#ce

;Version must be manually set 3 times in Directives below
;Version must be set in first line of GUI defination
Global $Version = '1.4'

#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=GeorgeController.ico
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Res_Description=George Controller
#AutoIt3Wrapper_Res_Fileversion=1.4.0.2
#AutoIt3Wrapper_Res_FileVersion_AutoIncrement=P
#AutoIt3Wrapper_Res_ProductVersion=1.4
#AutoIt3Wrapper_Res_Field=ProductVersion|Version 1.4
#AutoIt3Wrapper_Res_Field=Productname|Control
#AutoIt3Wrapper_Res_Field=Publisher|Hope United Church
#AutoIt3Wrapper_Res_LegalCopyright=© Copyright Paul Verboom 2020
#AutoIt3Wrapper_Res_Comment=Controls SONY Visca Cameras and various video hardware

#include <MsgBoxConstants.au3>						;message Box Constants
#include <Misc.au3>									;Singleton function need to check for 2nd occurance
#include <GuiListBox.au3>							;Read selected item(s) in a GUI list
#include <GUIConstants.au3>
#include <GUIConstantsEx.au3>						;Needed to set up GUI
#include <AutoItConstants.au3>						;Needed for Hex conversion function
#include <Misc.au3>
#include <Array.au3>								;for Array Display used is Debugging
#include <ColorConstants.au3>						;For turning Unavailable Camera buttons red
#include <File.au3>									;Required for saving settings and dealing with paths

#include <WindowsConstants.au3>						;Needed to detect double clicks
#include <ListBoxConstants.au3>
#include <StructureConstants.au3>


#pragma compile(inputboxres, true)

;-----------------------------
;-- Globals used by Modules --
;-----------------------------
Global $g_Title = StringRegExpReplace(@ScriptName,".exe|.au3","")							;Define Title so it is available for all other Dialogs
Global $g_Config = StringRegExpReplace(@ScriptFullPath,".exe|.au3",".ini",1)				;Get the full path to the Configuration INI file
Global $g_Debug = IniRead($g_Config,"Config","Debug","")									;Set Debug values see INI file for available debug values
Global $g_bStatus = False																	;set to true to update status window in GUI used by numerious Modules

Global $gR_aRelays[0][3]																	;Details on relays, established here so rows can be added by module
																							;1st demension one row per relay
																							;2nd dimension values
																							;	0 = Realy Name also INI Section name
																							;	1 = Serial number of relay
																							;	2 = Handle for relay

Global $g_aVscCmd[0]								;Array for Visca Command Queue
													;newest commands inserted at start of array element 0 pushing all others upward
													;Buffer must clear before $gV_bWait clears and Selected Camera can change
													;Global so functions can add more commands
Global $aPrst[0][2]									;Presets for selected Cameras
													;2nd dimension actual values for individual preset
													;	0 = name
													;	1 = PanValue (x)|TiltValue (y)|ZoomValue (z)
Global $aMcrStored[0][2]							;Stored Macros, Accessed by Save and Load functions and WebSite Index generation
													;X - each Macro
													;Y - 0 = Name of Macro
													;    1 = Contents of macro Macros seperated by @CR parameters seperated by PIPE |

Global $iCam = 1									;Current selected Camera
Global $iCamFnd = 0									;Number of cameras found
Global $iPrstUpdate = -1							;Flag update GUI listing of Presets -2 = no update, -1 update, >-1 update and indicates item to select
													;References to GUI used in Modules Main
Global $hForm										;Main handle to form
Global $hPTpad										;The Pan/Tilt Mouse control pad
Global $hZOOMpad									; The ZOOM control mouse pad
Global $hPresets									;List with Presets
Global $hEDID										;Displays EDID mode of 4X4 Matrix switch

#cs
Additional Globals are defined in Modules primarily for use in the Modules
These globals have the following name format;
A beta version was used that allowed these Globals to all be based on a single Global MAP variable
But the _GDIPlus commands used for the Matrix did not work in the Beta
$gV_...		- _VISCA module - does all communication with cameras
$gP_...		- _Pan 			- processes Pan Tilt Zoom pads in GUI
$gG_...		- _GAME 		- Does all Joystick Gamepad processing
$gR_...		- _Relay 		- Controls HID interfaced USB relays
$gW_...		- _Web 			- Plovides basic webserver interface to remotely activate a macro
#ce

;-------------
;-- Modules --
;-------------
#include 'CommMG.au3'								;or if you save the commMg.dll in the @scripdir use #include @SciptDir & '\commmg.dll'
#include '_VISCA.au3'								;Provides communication to VISCA protocol Cameras
#include '_Pad.au3'									;Implements Mouse drag pads for camera control
#include '_Game.au3'								;Implenets Gamepad/JoyStick control of Cameras
#include '_Matrix.au3'								;Creates updates Matrix Switches
#include '_4X4.au3'									;Controls 4X4 HDMI matrix switch
#include '_6X6.au3'									;Controls Krammer 6X6 Composite video switch
#include '_ProjA.au3'								;Controls Projector A
#include '_ProjB.au3'								;Controls Projector B
#include '_Relay.au3'								;Controls HID Interfaced USB relays
#include '_Web.au3'									;Provides simple web interface

;---------------------------------------------
;-- Initialize Stuff that Must Exist to Run --
;---------------------------------------------
_VerifyFile($g_Config,"Configuration file")															;Verify we have configuration file
Local $Icon = StringRegExpReplace(@ScriptFullPath,".exe|.au3",".ico",1)								;Get the full path to the Configuration INI file
_VerifyFile($Icon,"ICON file")																		;Verify we have icon file
_VerifyFile("PTpad.bmp","Pan/Tilt Pad BMP image File")
_VerifyFile("ZOOMpad.bmp","ZOOM Pad BMP Image File")

;--------------------------------------
;-- Global Stuff Only in This Module --
;--------------------------------------



Global $aPrstAll[7]									;Presets All Cameras Array of Array
FOR $n = 0 to 6										;Selected camera copied to from $aPrst
	$aPrstAll[$n] = $aPrst							;Presets are Global so Load Save Functions can access
Next
Global $hFileName									;Handle for Settings FileName displayed in GUI
													;Global so Load Save Functions can set

Global $hPresets									;Used to detect double click in Preset ListBox
Global $bPresetDublClck = False						;Set true when Double click in Presets occurs
Global $hMacros										;used to detect double click in Macro ListBox
Global $bMacroDublClck = False						;Set true when Double click in Presets occurs
Global $iMcrUpdate = -1								;Flag update GUI listing of Macros -2 = no update, -1 update, >-1 update and indicates item to select
GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")			;AutoIt Function that processes Window messages??

;----------------------------------
;-- Non Global Stuff this module --
;----------------------------------
Local $aMacro[0]									;Macro commands to execute
Local $bMcrRec = False								;True = Macro Record mode
Local $McrList = ''									;Macro being recorded or played back $McrList@CRLF seperated string
Local $bMcrPlay = False								;True = Macro played back
Local $McrPlay = ''									;Macro being played back each command added as it is played
Local $bProjAmute = False							;Projector Mute status used to toggle Mute ON/OFF default False Mute Off
Local $bProjBmute = False
Local $bPwrOther = False							;Status of Power control used to Toggle Power ON/OFF with one button
Local $bPwrAmp = False
Local $bShutDown = False							;Flag set to effect shut down of application

;-------------------------
;-- Setup stuff for GUI --
;-------------------------
Opt("GUIOnEventMode", 0) 							;Disable Events in GUI too much in main loop cannot be interrupted
Local $iPrstUpdate = -1								;Flag update GUI listing of Presets -2 = no update, -1 update, >-1 update and indicates item to select
Local $BlnkGrphc = @ScriptDir & '\blank.bmp'		;Initial Blank Graphic used for switch matrixes, replaced when Matric is iniltialized

#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>

#cs
Screen resolution of control computer is 1024 x 768
Windows controls enlarged to make Touch Screen Usable
Makes Menu Bar and application title Bars larger
Usable width 1024 - 10 pixels for board each side = 1004
Usable Height 768 - 40 Title Bar - (768  - 726) Menu bar = 686
Make GUI 1000 wide and 680 High


When inserting Koda generated code
Only insert with #Region ### START Koda GUI section ###
Turn OFF all Options under Tools -> Generating Options...
Remove Paths from *.BMP files
Replace file named in
$id4x4 = GUICtrlCreatePic(...
and
$id6X6 = GUICtrlCreatePic(
with
$BlnkGrphc
Ensure last two paramter in following line are on screen or 1,1
Update version number in same line
$hForm = GUICreate(....
#ce

#Region ### START Koda GUI section ### Form=E:\Projects\AutoIt\GeorgeController\GeorgeController.kxf
$hForm = GUICreate("George Controller Ver 1.4", 1009, 686, 1, 1)
$Group_Settings = GUICtrlCreateGroup("Settings", 8, 384, 577, 41)
$hFileName = GUICtrlCreateLabel("", 208, 402, 372, 20)
$idBut_Save = GUICtrlCreateButton("Save", 80, 400, 49, 17)
$idBut_Load = GUICtrlCreateButton("Load", 24, 400, 49, 17)
$idBut_SaveAs = GUICtrlCreateButton("Save As", 136, 400, 49, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group_Camera = GUICtrlCreateGroup("Camera", 8, 0, 577, 377)
$hPTpad = GUICtrlCreatePic("PTpad.bmp", 16, 16, 250, 250)
$hZOOMpad = GUICtrlCreatePic("ZOOMpad.bmp", 276, 16, 60, 250)
$hCameras = GUICtrlCreateGroup("Camera Selector", 16, 272, 561, 50)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group_Presets = GUICtrlCreateGroup("Presets", 344, 8, 233, 257)
$hPresets = GUICtrlCreateList("", 352, 24, 161, 222, BitOR($LBS_NOTIFY,$WS_VSCROLL,$WS_BORDER))
GUICtrlSetFont(-1, 14, 400, 0, "MS Sans Serif")
$idBut_Add = GUICtrlCreateButton("Add", 520, 72, 50, 25)
$idBut_Update = GUICtrlCreateButton("Update", 520, 104, 50, 25)
$idBut_Delete = GUICtrlCreateButton("Delete", 520, 168, 50, 25)
$idBut_Rename = GUICtrlCreateButton("Rename", 520, 136, 50, 25)
$idBut_Recall = GUICtrlCreateButton("Recall", 520, 24, 49, 41)
$idBut_Up = GUICtrlCreateButton("Up", 520, 200, 49, 25)
$idBut_Down = GUICtrlCreateButton("Down", 520, 232, 49, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group_Status = GUICtrlCreateGroup("Status", 16, 328, 561, 41)
$hStatusFull = GUICtrlCreateLabel("", 24, 344, 484, 23)
$idBut_Clear = GUICtrlCreateButton("Clear", 520, 344, 49, 17)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$id4X4 = GUICtrlCreatePic($BlnkGrphc, 8, 464, 241, 209)
$id6X6 = GUICtrlCreatePic($BlnkGrphc, 256, 464, 329, 209)
$id4X4read = GUICtrlCreateButton("Read Switch Settings", 8, 440, 113, 20)
$id6X6read = GUICtrlCreateButton("Read Switch Settings", 254, 440, 113, 20)
$Group1 = GUICtrlCreateGroup("Macros", 768, 0, 233, 673)
$hMacros = GUICtrlCreateList("", 776, 16, 217, 644, BitOR($LBS_NOTIFY,$WS_VSCROLL,$WS_BORDER))
GUICtrlSetFont(-1, 18, 400, 0, "MS Sans Serif")
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group2 = GUICtrlCreateGroup("Projector B", 592, 48, 81, 209)
$idbut_ProjBon = GUICtrlCreateButton("ON", 600, 64, 65, 25)
$idbut_ProjBstandby = GUICtrlCreateButton("Standby", 600, 96, 65, 25)
$idbut_ProjBvga = GUICtrlCreateButton("VGA", 600, 128, 65, 25)
$idbut_ProjBvideo = GUICtrlCreateButton("Video", 600, 160, 65, 25)
$idbut_ProjBhdmi = GUICtrlCreateButton("HDMI", 600, 192, 65, 25)
$idbut_ProjBmute = GUICtrlCreateButton("AV Mute", 600, 224, 65, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group3 = GUICtrlCreateGroup("Projector A", 680, 48, 81, 209)
$idbut_ProjAon = GUICtrlCreateButton("ON", 688, 64, 65, 25)
$idbut_ProjAstandby = GUICtrlCreateButton("Standby", 688, 96, 65, 25)
$idbut_ProjAvga = GUICtrlCreateButton("VGA", 688, 128, 65, 25)
$idbut_ProjAvideo = GUICtrlCreateButton("Video", 688, 160, 65, 25)
$idbut_ProjAhdmi = GUICtrlCreateButton("HDMI", 688, 192, 65, 25)
$idbut_ProjAmute = GUICtrlCreateButton("AV Mute", 688, 224, 65, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group4 = GUICtrlCreateGroup("Screen B", 592, 256, 81, 81)
$idbut_ScrnBup = GUICtrlCreateButton("Up", 600, 272, 65, 25)
$idbut_ScrnBdown = GUICtrlCreateButton("Down", 600, 304, 65, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group5 = GUICtrlCreateGroup("Screen A", 680, 256, 81, 81)
$idbut_ScrnAup = GUICtrlCreateButton("Up", 688, 272, 65, 25)
$idbut_ScrnAdown = GUICtrlCreateButton("Down", 688, 304, 65, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
$Group6 = GUICtrlCreateGroup("Macros", 592, 336, 169, 337)
$idbut_McrPlay = GUICtrlCreateButton("Play", 600, 352, 153, 41)
$idbut_McrRecord = GUICtrlCreateButton("Record", 600, 400, 65, 25)
$idBut_McrNew = GUICtrlCreateButton("New", 688, 400, 65, 25)
$idbut_McrRename = GUICtrlCreateButton("Rename", 600, 432, 65, 25)
$idbut_McrDelete = GUICtrlCreateButton("Delete", 688, 432, 65, 25)
$idbut_McrUp = GUICtrlCreateButton("Move Up", 600, 464, 65, 25)
$idbut_McrDown = GUICtrlCreateButton("Move Down", 688, 464, 65, 25)
$hMcrRec = GUICtrlCreateEdit("", 600, 496, 153, 169, BitOR($ES_AUTOVSCROLL,$ES_WANTRETURN,$WS_VSCROLL))
GUICtrlCreateGroup("", -99, -99, 1, 1)
$EDID = GUICtrlCreateLabel("EDID", 128, 440, 30, 17, BitOR($SS_CENTER,$SS_CENTERIMAGE))
$hEDID = GUICtrlCreateInput("hEDID", 168, 440, 17, 21, BitOR($ES_CENTER,$ES_READONLY))
$Group8 = GUICtrlCreateGroup("Power", 592, 0, 169, 49)
$idbut_PowerOther = GUICtrlCreateButton("All Other", 600, 16, 65, 25)
$idbut_PowerAmp = GUICtrlCreateButton("Audio Amp", 688, 16, 65, 25)
GUICtrlCreateGroup("", -99, -99, 1, 1)
GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###



_LoadSettings(False)																				;Load settings but do not prompt for name if no settings file name in INI then no load
																									;Done now so file name can be displayed in GUI
$iPrstUpdate = -1																					;Update Preset and Macro List in GUI
$iMcrUpdate = -1																					;but do not select one of them
$iLastMacro = -1																					;last macro selected

;------------------------
;-- Initialize Modules --
;------------------------
_PadSetup()											;Initialize Pan/Title Zoom pad variables
_GameSetup()										;Initialize Gamepad/Joystick
IF NOT StringInStr($g_Debug,"y") Then				;Unless webserver is disabled by debugging flag
	_WEBintial()									;Initialize Webserver
EndIf

;-------------------
;-- Relay Control --
;-------------------
Global $gR_aRelays[0][3]														;Details on relays, established here so rows can be added
																				;1st dimension one row per relay
																				;2nd dimension values
																				;	0 = Relay Name also INI Section name
																				;	1 = Serial number of relay
_RelayGetSerial('Power')														;Initialize USB Power Relay from INI or enumeration
_RelayGetSerial('Screen')														;Initialize USB Power Relay from INI or enumeration

;----------------------
;-- Open Camera port --
;----------------------
$iCamFnd = _VSCopen()																				;Open RS232 port to cameras determine how many camera out there
IF $iCamFnd < 1 AND StringInStr($g_Debug,"g") Then													;Error out if no cameras detected
	MsgBox($MB_ICONERROR,$g_Title,"No Cameras detected" & @CRLF & "Program will terminate")
	_Commcloseport(true)
	Exit
EndIf
Local $iCamCnt = IniRead($g_Config,"Cameras","Count",1) 											;Get number of Cameras configured
IF StringInStr($g_Debug,'f') Then
	$iCamFnd = $iCamCnt																				;To test Camera selection buttons force to setting in INI
ELSE
	IF $iCamCnt <> $iCamFnd Then
		MsgBox($MB_ICONERROR,$g_Title,"Number Cameras detected: " & $iCamFnd & @CRLF & "Number Cameras configured: " & $iCamCnt)
	EndIf
EndIf
Local $aCamPos = ControlGetPos($hForm, "", $hCameras)												;Get the position of the Camera Buttons
Local $iCamSpc = 8																					;space around camera buttons
Local $iCamBtWdth = ($aCamPos[2] - (($iCamCnt + 1) * $iCamSpc)) / $iCamCnt
Local $iCamBtHght = $aCamPos[3] - ($iCamSpc *2)
Local $iCamBtXoffset = $aCamPos[0] + $iCamSpc
Local $iCamBtYoffset = $aCamPos[1] + $iCamSpc + 4

Local $aCamBtHnd[$iCamCnt + 1]																		;Handles for different camera buttons 1 based so elements align with camera numbers

FOR $n = 1 TO $iCamCnt
	$aCamBtHnd[$n] = GUICtrlCreateButton(IniRead($g_Config,"Cameras",$n,"Camera " & $n),$iCamBtXoffset,$iCamBtYoffset,$iCamBtWdth,$iCamBtHght)
	IF $n > $iCamFnd Then GUICtrlSetBkColor($aCamBtHnd[$n], $COLOR_FUCHSIA)							;Color unavailable cameras red
	$iCamBtXoffset += 	$iCamBtWdth + $iCamSpc
NEXT
IF $iCamFnd > 0 Then
	GUICtrlSetBkColor($aCamBtHnd[$iCam], $COLOR_YELLOW)												;Highlight that button with a color
EndIf

;---------------------------
;-- Initialize 4X4 Matrix --
;---------------------------
Local $a4X4Select[4] = [0,0,0,0]												;Storage of selected channels one Output per element
Local $nEDID = 1																;The EDID mode used by switch
_4X4open($a4X4Select,$nEDID)													;Open The RS232 port to 4X4 HDMI Matrix Switch and get current Settings
Local $a4X4SelectposV[0]														;Position of channels in the Y vertical direction sized when Matrix is drawn
Local $a4X4SelectposH[0]														;Position of channels in the X horizontal direction sized when Matrix is drawn
Local $i4X4Output
Local $i4X4Input
_Matrix($id4x4,'4X4',$a4X4Select,$a4X4SelectposV,$a4X4SelectposH)


;---------------------------
;-- Initialize 6X6 Matrix --
;---------------------------
Local $a6X6Select[6] = [0,0,0,0,0,0]
_6X6open($a6X6Select)
Local $a6X6SelectposV[0]														;Position of channels in the Y vertical direction sized when Matrix is drawn
Local $a6X6SelectposH[0]														;Position of channels in the X horizontal direction sized when Matrix is drawn
Local $i6X6Output
Local $i6X6Input
_Matrix($id6X6,'6X6',$a6X6Select,$a6X6SelectposV,$a6X6SelectposH)

;--------------------------
;-- Open Projector Ports --
;--------------------------
_ProjAopen()
_ProjBopen()

;---------------
;-- Main loop --
;---------------
Local $iSleep = IniRead($g_Config,'Config','Sleep',5)												;Sleep in milliseconds during each processing loop determines responsiveness
OnAutoItExitRegister("OnAutoItExit")																;Register a function to shut down everything on exit regaless how we exit
While 1																								;Main loop program now stays is

	;---------------------------------
	;-- Processing in other modules --
	;---------------------------------
	_GameProcess()																					;Process Gamepad/Joystick movements
	_PadProcess()																					;Process Pan/Tilt & Zoom Pad
	_VscProcess()																					;Process VISCA commands

	;--------------------------------
	;-- Process GUI Button presses --
	;--------------------------------
	$nMsg = GUIGetMsg()																				;get any message from GUI

	;-----------------------------------------------------------------------------------
	;-- Process GUI Stuff that can happen while waiting for VISCA command to complete --
	;-----------------------------------------------------------------------------------
	Switch $nMsg																					;Stuff that can happen while waiting for a Camera command to complete
		Case $GUI_EVENT_CLOSE
			While True																				;NOT a loop but an easy block of code to exit
				IF StringInStr($g_Debug,'e') THEN
					IF MsgBox($MB_YESNO, "Exit", "Are you sure you wish to Exit") = $IDNO Then
						ExitLoop
					EndIf
				EndIf
				IF $iLastMacro >= 0 AND $iLastMacro < UBOUND($aMcrStored,1) Then					;Save any changes to the Macro
					$McrList = GUICtrlRead($hMcrRec)												;provided we have a valid macro selected
					$aMcrStored[$iLastMacro][1] = $McrList											;avoid out of bound errors
				EndIf
				IF NOT StringInStr($g_Debug,"s") Then												;Save settings do not prompt for name use existing name
					_SaveSettings(False)															;do before playing shutdown macro which can get interrupted
				EndIf																				;during machine shutdown
				Local $ShutDownMacro = IniRead($g_Config,'Config','ShutDownMacro','~~~~~~~')		;see if we have a shut down macro in effect
				Local $nMcrSel = _ArraySearch($aMcrStored,$ShutDownMacro,0,0,0,0,1,0)				;Look for a ShutDown Macro
				IF $nMcrSel >= 0 Then 																;Shut Down Macro found
					$bShutDown = True																;Set Flag so we shut down after this macro plays
					$bMcrPlay = True																;Initiat the Macro Playback Mode
					$McrList = ''																	;Clear the MacroList
					GUICtrlSetBkColor($idBut_McrPlay, $COLOR_YELLOW)								;Highlight button indicate Macro playback
					$aArray = StringSplit($aMcrStored[$nMcrSel][1],@CRLF)							;Split multiline macro into array
					For $i = 1 to $aArray[0]														;and add each element to macro Playback array
						_McrCmdAdd($aArray[$i])
					Next
				EndIf
				$bShutDown = True
				ExitLoop
			WEND

		Case $idBut_Clear
			While UBOUND($g_aVscCmd) > 0 															;Clear any pending VISCA commands
				$VscCmd = _ArrayPop($g_aVscCmd)
			Wend
			$gV_CamStatus = ''																		;Clear any messages
			$gV_PanLbl = ''
			$gV_TltLbl = ''
			$gV_bWait = False																		;clear Wait
			$g_bStatus = True																		;Forse update of Status

		case $id4X4																					;User clicked on 4X4 matrix picture see if they clicked on intersection of lines and then update
			IF _MatrixClick($id4X4,'4X4',$a4X4Select,$a4X4SelectposV,$a4X4SelectposH,$i4X4Output,$i4X4Input,True) then
				_DebugMess("4",'4X4 Matrix Output: ' & $i4X4Output & ' Input: ' & $i4X4Input)		;Trace out the Output that was changed
				_McrCmdAdd('4X4|' & $i4X4Output & '|' & $i4X4Input)									;Have macro processing make actual change
			EndIf
		case $id4X4read
			_4X4read($a4X4Select, $nEDID)
			_Matrix($id4x4,'4X4',$a4X4Select,$a4X4SelectposV,$a4X4SelectposH)						;No real errors returned
		case $id6X6																					;User clicked on 4X4 matrix picture see if they clicked on intersection of lines and then update
			IF _MatrixClick($id6X6,'6X6',$a6X6Select,$a6X6SelectposV,$a6X6SelectposH,$i6X6Output,$i6X6Input,True) then
				_DebugMess("6",'4X4 Matrix Output: ' & $i6X6Output & ' Input: ' & $i6X6Input)		;Trace out the Output that was changed
				_McrCmdAdd('6X6|' & $i6X6Output & '|' & $i6X6Input)									;have Macro processing make actual change
			EndIf
		case $id6X6read
			_6X6read($a6X6Select)
			_Matrix($id6x6,'6X6',$a6X6Select,$a6X6SelectposV,$a6X6SelectposH)						;No real errors returned
		case $idbut_PowerOther
			IF $bPwrOther Then
				GUICtrlSetStyle($idbut_PowerOther, $GUI_SS_DEFAULT_BUTTON)							;Unhightlight button indicate A/V Mute OFF
				_McrCmdAdd('PowerOther|OFF')
				$bPwrOther = False
			Else
				GUICtrlSetBkColor($idbut_PowerOther, $COLOR_YELLOW)									;Highlight button indicate A/V Mute Turned ON
				_McrCmdAdd('PowerOther|ON')
				$bPwrOther = True
			EndIf
		case $idbut_PowerAmp
			IF $bPwrAmp Then
				GUICtrlSetStyle($idbut_PowerAmp, $GUI_SS_DEFAULT_BUTTON)							;Unhightlight button indicate A/V Mute OFF
				_McrCmdAdd('PowerAmp|OFF')
				$bPwrAmp = False
			Else
				GUICtrlSetBkColor($idbut_PowerAmp, $COLOR_YELLOW)									;Highlight button indicate A/V Mute Turned ON
				_McrCmdAdd('PowerAmp|ON')
				$bPwrAmp = True
			EndIf
		case $idbut_ProjBon																			;Projector Buttons
			_McrCmdAdd('ProjectorB|ON')
		Case $idbut_ProjBstandby
			_McrCmdAdd('ProjectorB|Standby')
		Case $idbut_ProjBvga
			_McrCmdAdd('ProjectorB|VGA')
		Case $idbut_ProjBvideo
			_McrCmdAdd('ProjectorB|Video')
		Case $idbut_ProjBhdmi
			_McrCmdAdd('ProjectorB|HDMI')
		Case $idbut_ProjBmute
			IF $bProjBmute Then
				GUICtrlSetStyle($idbut_ProjBmute, $GUI_SS_DEFAULT_BUTTON)							;Unhightlight button indicate A/V Mute OFF
				_McrCmdAdd('ProjectorB|MUTE OFF')
				$bProjBmute = False
			Else
				GUICtrlSetBkColor($idbut_ProjBmute, $COLOR_YELLOW)									;Highlight button indicate A/V Mute Turned ON
				_McrCmdAdd('ProjectorB|MUTE ON')
				$bProjBmute = True
			EndIf
		Case $idbut_ProjAon
			_McrCmdAdd('ProjectorA|ON')
		Case $idbut_ProjAstandby
			_McrCmdAdd('ProjectorA|Standby')
		Case $idbut_ProjAvga
			_McrCmdAdd('ProjectorA|VGA')
		Case $idbut_ProjAvideo
			_McrCmdAdd('ProjectorA|Video')
		Case $idbut_ProjAhdmi
			_McrCmdAdd('ProjectorA|HDMI')
		Case $idbut_ProjAmute
			IF $bProjAmute Then
				GUICtrlSetStyle($idbut_ProjAmute, $GUI_SS_DEFAULT_BUTTON)							;Unhightlight button indicate A/V Mute OFF
				_McrCmdAdd('ProjectorA|MUTE OFF')
				$bProjAmute = False
			Else
				GUICtrlSetBkColor($idbut_ProjAmute, $COLOR_YELLOW)									;Highlight button indicate A/V Mute Turned ON
				_McrCmdAdd('ProjectorA|MUTE ON')
				$bProjAmute = True
			EndIf
		Case $idbut_ScrnBup
			_McrCmdAdd('ScreenB_Up')
		Case $idbut_ScrnBdown
			_McrCmdAdd('ScreenB_Down')
		Case $idbut_ScrnAup
			_McrCmdAdd('ScreenA_Up')
		Case $idbut_ScrnAdown
			_McrCmdAdd('ScreenA_Down')
	EndSwitch

	;------------------------------------------------------------------------
	;-- Stuff that happens after VISCA wait and Macro playback is complete --
	;------------------------------------------------------------------------
	IF NOT $gV_bWait AND UBOUND($aMacro) = 0 Then													;Stuff that only processed once we are clear of all Camera Commands and NO macro command outstanding
																									;IE changing Camera mid Camera Pan operation will cause ACKS not to be seen etc.
		;-----------------------
		;-- Complete Shutdown --
		;-----------------------
		IF $bShutDown Then																				;ShutDown initiated in GUI process loop above
			Exit																					;but only completes after any ShutDown macro has completed
		EndIf

		;-------------------
		;-- Select Camera --
		;-------------------
		For $n = 1 TO $iCamCnt																		;See if user pressed a camera selection button
			IF $aCamBtHnd[$n] = $nMsg Then															;a Camera selection button
				IF $n > $iCamFnd Then																;Verify Camera selected exist
					MsgBox($MB_ICONERROR,$g_Title,"Undetected Camera Selected")						;If we allow a non existing camera to be selected we will hang
				Else																				;when waiting for a ACK from the none existing camera
					_McrCmdAdd('CameraSelect|' & $n)												;Have macro processor actually change the camera
				EndIf
			EndIf
		Next

	   ;---------------------------------------
	   ;-- Check for double click in Presets --
	   ;---------------------------------------
   		IF $bPresetDublClck Then
			Local $PrstName = GUICtrlRead($hPresets)												;retrieve name of preset selected
			IF StringLen($PrstName) > 0 Then														;if any pass Macro playback
				_McrCmdAdd('PresetRecall|' & $PrstName)
			EndIf
			$bPresetDublClck = False
		EndIf

		;------------------------------------
		;-- Check change in selected Macro --
		;------------------------------------
		$i = _GUICtrlListBox_GetCurSel($hMacros)													;Get Macro currently selected
		IF $i <> $iLastMacro AND $i > -1 Then														;Valid Change in selected macro
			IF $bMcrRec Then																		;MACRO Record mode on turn it off
				$bMcrRec = False
				GUICtrlSetColor($idbut_McrRecord,$COLOR_BLACK)										;reset highlight of Record button
				GUICtrlSetFont($idbut_McrRecord,8.5,$FW_NORMAL)
			EndIf
			IF $iLastMacro >= 0 AND $iLastMacro < UBOUND($aMcrStored,1) Then						;Save any changes to the Current Macro
				$McrList = GUICtrlRead($hMcrRec)													;provided we have a valid macro selected
				$aMcrStored[$iLastMacro][1] = $McrList												;avoid out of bound errors
			EndIf
			IF $i >= 0 AND $i < UBOUND($aMcrStored,1) Then											;Display contents of selected macro in GUI
				$McrList = $aMcrStored[$i][1]														;provided we have valid one selected
				GUICtrlSetData($hMcrRec,$McrList)													;avoid out of bound errors
				$iLastMacro = $i																	;rember macro currently display in Edit Box
			EndIf																					;so we can detect changes
		EndIf

		;-------------------------------------
		;-- Check for double click in Macro --
		;-------------------------------------
   		IF $bMacroDublClck Then
			IF $bMcrRec Then																		;Verify not in Macro record Mode
				$gV_CamStatus = 'Unable to Play Macro Recording in progress'
				$g_bStatus = True
			Else
				$i = _GUICtrlListBox_GetCurSel($hMacros)											;Get selected Macro if any selected
				IF $i <> -1 Then																	;Macro is selected normally before double click is processed
					$bMcrPlay = True																;Initiat the Macro Playback Mode
					$McrList = ''																	;Clear the MacroList
					GUICtrlSetData($hMcrRec,$McrList)
					GUICtrlSetBkColor($idBut_McrPlay, $COLOR_YELLOW)								;Highlight button indicate Macro playback
					$aArray = StringSplit($aMcrStored[$i][1],@CRLF)									;Split multiline macro into array splits on CR and on LF
					For $i = 1 to $aArray[0]														;and add each element to macro Playback array
						IF StringLen($aArray[$i]) > 0 Then											;removed blank lines resulting from @CRLF pairs
							_McrCmdAdd($aArray[$i])
						EndIf
					Next
				EndIf
			EndIf
			$bMacroDublClck = False
		EndIf

		;----------------------------------------
		;-- Check for WebServer selected Macro --
		;----------------------------------------
		IF NOT StringInStr($g_Debug,"y") Then														;Unless webserver is disabled by debugging flag
			$nMacro = _WEBprocess()																	;check for macro selected by web Server
			IF $nMacro  >= 0 Then
				IF $bMcrRec Then																	;Verify not in Macro record Mode
					$gV_CamStatus = 'Unable to Play Macro Recording in progress'
					$g_bStatus = True
				Else
					IF $iLastMacro >= 0 AND $iLastMacro < UBOUND($aMcrStored,1) Then				;Save any changes to the Current Macro
						$McrList = GUICtrlRead($hMcrRec)											;provided we have a valid macro selected
						$aMcrStored[$iLastMacro][1] = $McrList										;avoid out of bound errors
					EndIf
					$bMcrPlay = True																;Initiat the Macro Playback Mode
					$McrList = ''																	;Clear the MacroList
					GUICtrlSetBkColor($idBut_McrPlay, $COLOR_YELLOW)								;Highlight button indicate Macro playback
					$aArray = StringSplit($aMcrStored[$nMacro][1],@CRLF)							;Split multiline macro into array
					For $i = 1 to $aArray[0]														;and add each element to macro Playback array
						_McrCmdAdd($aArray[$i])
					Next																			;Set the current macro selected to the one selected by web browser
					$iMcrUpdate = $nMacro															;and force update on Macro list
					$iLastMacro = $nMacro															;Set the macro just played to the last Macro
				Endif
			EndIf
		EndIf

		;-----------------------------------------------------------------------------
		;-- Process GUI Stuff that can only happen when no VISCA command is waiting --
		;-----------------------------------------------------------------------------
		Switch $nMsg

			;----------------
			;-- Add Preset --
			;----------------
			Case $idBut_Add																			;Add a Preset
				WHILE True																			;NOT a loop easy to exit block of code
					Local $StrdPrst = _VscGetPreset()												;Get Stored values for preset PIPE seperated values with leading PIPE
					IF StringLen($StrdPrst) = 0 Then ExitLoop										;if we have value continue and get name
					$PrstName = _GetName($aPrst,'Name of Preset to add')							;Get name of Preset
					IF @error Then ExitLoop
					_ArrayAdd($aPrst,$McrList,1,'~','~', $ARRAYFILL_FORCE_SINGLEITEM)				;Add Macro Recording as a single item
					$iPrstUpdate = UBound($aPrst)-1													;Force update of GUI List of Presets, selecting newly added entry
					$aPrst[$iPrstUpdate][0] = $PrstName												;Add the Macro Name
					$aPrst[$iPrstUpdate][1] = $StrdPrst												;Add the values for the Macro
					$gV_CamStatus = 'Added Preset: ' & $PrstName
					$g_bStatus = True
					ExitLoop
				WEnd

			;-------------------
			;-- Update Preset --
			;-------------------
			Case $idBut_Update
				$i = _GUICtrlListBox_GetCurSel($hPresets)											;Get selected Preset if any selected
				IF $i > -1 Then																		;we have a Preset selected
					Local $StrdPrst = _VscGetPreset()												;Get values for preset
					IF StringLen($StrdPrst) = 0 Then ExitLoop										;if we have value continue and get name
					$aPrst[$i][1] = $StrdPrst
					$gV_CamStatus = 'Preset updated: ' & $aPrst[$i][0]
					$g_bStatus = True
				EndIf

			;-------------------
			;-- Rename Preset --
			;-------------------
			Case $idBut_Rename
				$i = _GUICtrlListBox_GetCurSel($hPresets)											;Get selected Preset if any selected
				IF $i <> -1 Then
					Local $PrstName = _GetName($aPrst,'New name for Preset')						;Get name of Preset
					IF NOT @error Then																;Build status message while we have both old and new names
						$gV_CamStatus = 'Preset renamed from: ' & $aPrst[$i][0] & ' to: ' & $PrstName
						$aPrst[$i][0] = $PrstName													;assign new name
						$iPrstUpdate = $i															;Update Preset List in GUI and select renamed Preset
						$g_bStatus = True
					EndIf
				EndIf

			;-------------------
			;-- Delete Preset --
			;-------------------
			CASE $idBut_Delete
				$i = _GUICtrlListBox_GetCurSel($hPresets)											;Get selected Preset if any selected
				IF $i <> -1 Then
					$gV_CamStatus = 'Preset deleted: ' & $aPrst[$i][0]								;Build status line while we still have name
					_ArrayDelete($aPrst,$i)
					$iPrstUpdate = -1																;Update Preset List in GUI but not select item as item is now deleted
					$g_bStatus = True																;Update status with line created
				EndIf

			;-------------------
			;-- Recall Preset --
			;-------------------
			CASE $idBut_Recall
				Local $PrstName = GUICtrlRead($hPresets)
				IF StringLen($PrstName) > 0 Then
					_McrCmdAdd('PresetRecall|' & $PrstName)
				EndIf

			;--------------------------
			;-- Save Presets to file --
			;--------------------------
			Case $idBut_Save																		;Also called without prompting when application is shut down
				_SaveSettings(False)
				$gV_CamStatus = 'Presets saved to: ' & IniRead($g_Config,'Settings','FileName','')
				$g_bStatus = True
			Case $idBut_SaveAs
				_SaveSettings(True)
				$gV_CamStatus = 'Presets saved to: ' & IniRead($g_Config,'Settings','FileName','')
				$g_bStatus = True

			;------------------
			;-- Load Presets --
			;------------------
			Case $idBut_Load																		;Also called without prompting when application is started up
				_LoadSettings(True)																	;Only loads presets if settings FileName specified in INI exists
				$iPrstUpdate = -1																	;Update Preset and Macro List in GUI
				$iMcrUpdate = -1																	;but do not select one of them
				$gV_CamStatus = 'Presets loaded from: ' & IniRead($g_Config,'Settings','FileName','')
				$g_bStatus = True

			;-------------------------
			;-- Move Preset Up List --
			;-------------------------
			Case $idBut_Up
				$i = _GUICtrlListBox_GetCurSel($hPresets)											;Get selected Preset if any selected
				IF $i > 0 Then
					_ArraySwap($aPrst,$i,$i-1)														;Swap selected line and one before
					$iPrstUpdate = $i -1															;Update Preset list in GUI and reselect moved preset
				EndIf

			;---------------------------
			;-- Move Preset Down List --
			;---------------------------
			Case $idBut_Down
				$i = _GUICtrlListBox_GetCurSel($hPresets)
				IF $i < UBound($aPrst) - 1 AND $i > -1 Then
					_ArraySwap($aPrst,$i,$i+1)														;Swap line and one after
					$iPrstUpdate = $i + 1															;Update Preset list in GUI and reselect moved preset
				EndIf

			;------------------
			;-- Macro Record --
			;------------------
			Case $idbut_McrRecord
				IF $bMcrRec Then																	;Record mode already on turn it off
					$bMcrRec = False
					GUICtrlSetColor($idbut_McrRecord,$COLOR_BLACK)									;reset highlight of button
					GUICtrlSetFont($idbut_McrRecord,8.5,$FW_NORMAL)
				Else
					$bMcrRec = True																	;Turn on record mode
					GUICtrlSetColor($idbut_McrRecord,$COLOR_RED)									;new macro commands added to end of macro
					GUICtrlSetFont($idbut_McrRecord,10,$FW_BOLD)									;highlight the button to indicate macro Mode
				EndIf

			;---------------
			;-- Macro New --
			;---------------
			Case $idBut_McrNew
				Local $McrName = _GetName($aMcrStored,'Name of Macro to save')						;get name of new macro
				IF NOT @error Then
					IF $bMcrRec Then																;If in record mode turn it off
						$bMcrRec = False															;and save the edited Macro as new Macro
						GUICtrlSetColor($idbut_McrRecord,$COLOR_BLACK)								;Unhighlight the Record Button
						GUICtrlSetFont($idbut_McrRecord,8.5,$FW_NORMAL)
					Else
						$i = _GUICtrlListBox_GetCurSel($hMacros)									;Get Macro currently selected
						IF $i >= 0 AND $i < UBOUND($aMcrStored,1) Then								;If it is valid macro number
							$McrList = GUICtrlRead($hMcrRec)										;update the stored copy
							$aMcrStored[$iLastMacro][1] = $McrList
						EndIf
						$McrList = ''																;Clear existing macro
						GUICtrlSetData($hMcrRec,$McrList)											;Create new blank macro
					EndIf
					_ArrayAdd($aMcrStored,$McrList,1,'~','~', $ARRAYFILL_FORCE_SINGLEITEM)			;Add Macro Recording as a single item
					$iMcrUpdate = UBound($aMcrStored)-1												;Force update of GUI List of Presets, selecting newly added entry
					$aMcrStored[$iMcrUpdate][0] = $McrName											;Add the Macro Name
					$iLastMacro = $iMcrUpdate														;Set this to the last macro Displayed
					$gV_CamStatus = 'Added New Macro: ' & $McrName
					$g_bStatus = True
				EndIf

			;----------------
			;-- Macro Play --
			;----------------
			Case $idBut_McrPlay
				IF $bMcrRec Then
					$gV_CamStatus = 'Unable to Play Macro Recording in progress'
					$g_bStatus = True
				Else
					$i = _GUICtrlListBox_GetCurSel($hMacros)										;Get selected Preset if any selected
					IF $i <> -1 Then
						$bMcrPlay = True															;Initiat the Macro Playback Mode
						$McrList = ''																;Clear the MacroList
						GUICtrlSetData($hMcrRec,$McrList)
						GUICtrlSetBkColor($idBut_McrPlay, $COLOR_YELLOW)							;Highlight button indicate Macro playback
						$aArray = StringSplit($aMcrStored[$i][1],@CRLF)								;will split of LF and CR if @CRLF pairs are used
						For $i = 1 to $aArray[0]
							IF StringLen($aArray[$i]) > 0 Then										;removed blank lines resulting from @CRLF pairs
								_McrCmdAdd($aArray[$i])
							EndIf
						Next
					EndIf
				EndIf

			;-------------------
			;-- Rename Macro --
			;-------------------
			Case $idBut_McrRename
				$i = _GUICtrlListBox_GetCurSel($hMacros)											;Get selected Preset if any selected
				IF $i <> -1 Then
					Local $McrName = _GetName($aMcrStored,'New name for Macro')						;Get name of Macro
					IF NOT @error Then																;Build status message while we have both old and new names
						$gV_CamStatus = 'Macro renamed from: ' & $aMcrStored[$i][0] & ' to: ' & $McrName
						$aMcrStored[$i][0] = $McrName												;assign new name
						$iMcrUpdate = $i															;Update Preset List in GUI and select renamed Preset
						$g_bStatus = True
					EndIf
				EndIf

			;-------------------
			;-- Delete Macro --
			;-------------------
			CASE $idbut_McrDelete
				IF $bMcrRec Then																	;If in macro record mode turn it off
					$bMcrRec = False																;as we are deleting the macro being recorded
					GUICtrlSetColor($idbut_McrRecord,$COLOR_BLACK)
					GUICtrlSetFont($idbut_McrRecord,8.5,$FW_NORMAL)
				EndIf
				$i = _GUICtrlListBox_GetCurSel($hMacros)											;Get selected Preset if any selected
				IF $i <> -1 Then
					$gV_CamStatus = 'Macro deleted: ' & $aMcrStored[$i][0]							;Build status line while we still have name
					_ArrayDelete($aMcrStored,$i)
					$iLastMacro = -1																;No last Macro we deleted it
					$McrList = ''																	;Clear existing macro and what is displayed
					GUICtrlSetData($hMcrRec,$McrList)
					$iMcrUpdate = -1																;Update Preset List in GUI but not select item as item is now deleted
					$g_bStatus = True																;Update status with line created
				EndIf

			;-------------------------
			;-- Move Macro Up List --
			;-------------------------
			Case $idbut_McrUp
				$i = _GUICtrlListBox_GetCurSel($hMacros)											;Get selected Preset if any selected
				IF $i > 0 Then
					_ArraySwap($aMcrStored,$i,$i-1)													;Swap selected line and one before
					$iMcrUpdate = $i - 1															;Update Preset list in GUI and reselect moved preset
					$iLastMacro = $i - 1 															;save the correct Macro when move off this macro
				EndIf

			;---------------------------
			;-- Move Macro Down List --
			;---------------------------
			Case $idbut_McrDown
				$i = _GUICtrlListBox_GetCurSel($hMacros)
				IF $i < UBound($aMcrStored) - 1 AND $i > -1 Then
					_ArraySwap($aMcrStored,$i,$i+1)													;Swap line and one after
					$iMcrUpdate = $i + 1															;Update Preset list in GUI and reselect moved preset
					$iLastMacro = $i + 1															;save the correct Macro when move off this macro
				EndIf


		EndSwitch

		_GameButtons()																				;Process Buttons on GamePad
	EndIf

	;----------------------------
	;-- Process Macro Commands --
	;----------------------------
	IF $bMcrPlay AND UBound($aMacro) = 0 Then														;Is Macro Playback in effect and we are at end of macro
		$bMcrPlay = False
		GUICtrlSetStyle($idBut_McrPlay, $GUI_SS_DEFAULT_BUTTON)										;Unhightlight Play button
	EndIf
	WHILE (NOT $gV_bWait) AND UBOUND($aMacro) > 0 													;Loop to playback Macro Commands
		$McrCmd = _ArrayPop($aMacro)																;Get macro from end of array, new commands inserted into start of array
		IF StringLen($McrCmd) = 0 Then ExitLoop														;If empty line in macro skip it do avoid lookup while updating McrList
		IF $bMcrRec Then																			;If recording macro get macro contents from edit control
			$McrList = GUICtrlRead($hMcrRec)														;in case end user edited before or during record mode
		EndIf
		IF $bMcrRec OR $bMcrPlay Then																;Add to Macro recording if Macro command in effect
			IF StringLen($McrList) > 0 AND StringRight($McrList,2) <> @CRLF Then					;If playPack is in effect add so we can see what is happening
				$McrList = $McrList & @CRLF															;add CR LF if something there and nor aready there
			EndIf
			$McrList = $McrList & $McrCmd
			GUICtrlSetData($hMcrRec,$McrList)
		EndIf
		$aMcrCmd = StringSplit($McrCmd,'|')															;Get command and its parameters
		IF $aMcrCmd[0] = 0 Then Exitloop															;verify we got a command, if not just skip it instead of having out of bound errors

		Switch $aMcrCmd[1] 																			;select what to do with command

			CASE  'CameraSelect'																	;Select a new camera'
				IF $aMcrCmd[0] <> 2 Then ExitLoop													;verify a camera number is in macro command
				$aPrstAll[$iCam-1] = $aPrst 														;Update Preset for camera from Presets array
				GUICtrlSetStyle($aCamBtHnd[$iCam], $GUI_SS_DEFAULT_BUTTON)							;Unhightlight existing button
				$iCam = $aMcrCmd[2]
				$aPrst = $aPrstAll[$iCam-1] 														;Update Preset Array with presets for this camera
				$iPrstUpdate = -1																	;Force update List of presets in GUI, but do not select one
				GUICtrlSetBkColor($aCamBtHnd[$iCam], $COLOR_YELLOW)									;Hightlight the newely selected camera

			Case 'PresetRecall'																		;Recall a preset
				IF $aMcrCmd[0] <> 2 Then ExitLoop													;verify a preset name is in macro command
				Local $nPrstSel = _ArraySearch($aPrst,$aMcrCmd[2],0,0,0,0,1,0)						;Look for Preset by name
				IF $nPrstSel >= 0 Then																;If Preset found then set Position and Zoom to Absolute values
					$StrdPrst = $aPrst[$nPrstSel][1]
					_VscSetPreset($aPrst[$nPrstSel][1])												;Send the values to be sent to camera
					If @error Then																	;error ifd incorrect number of elements retrieved
						$gV_CamStatus = 'Error in Preset: ' & $aPrst[$nPrstSel][0]
					Else
						$gV_CamStatus = 'Recalled Preset: ' & $aPrst[$nPrstSel][0]					;Update Status Line to what is happening
					EndIf
					_VscProcess()																	;Process VISCA command just added so Wait mode gets set
					$g_bStatus = True																;and we don't stuff more commands at the cameras
				EndIf

			Case '4X4'																				;Select differnet Input on 4X4 HDMI Matrix Switch
				IF $aMcrCmd[0] <> 3 Then ExitLoop													;verify Output and Input are in macro command
				_4X4set($aMcrCmd[2],$aMcrCmd[3])													;Set the selected 4X4 Output to selected input
				$a4X4Select[$aMcrCmd[2]] = $aMcrCmd[3]												;Update the display matrix
				_Matrix($id4x4,'4X4',$a4X4Select,$a4X4SelectposV,$a4X4SelectposH)

			Case '6X6'																				;Select differnet Input on Krammer 6X6 composite Video Matrix Switch
				IF $aMcrCmd[0] <> 3 Then ExitLoop													;verify Output and Input are in macro command
				_6X6set($aMcrCmd[2],$aMcrCmd[3])													;Set the selected 4X4 Output to selected input
				$a6X6Select[$aMcrCmd[2]] = $aMcrCmd[3]
				_Matrix($id6X6,'6X6',$a6X6Select,$a6X6SelectposV,$a6X6SelectposH)

			Case 'ProjectorA'																		;Command for Projector A
				IF $aMcrCmd[0] <> 2 Then ExitLoop
				_ProjAcmd($aMcrCmd[2])

			Case 'ProjectorB'																		;Command for Projector B
				IF $aMcrCmd[0] <> 2 Then ExitLoop
				_ProjBcmd($aMcrCmd[2])

			Case 'ScreenA_Up'																		;Control Screens
				_RelayScreen(1,$aMcrCmd[1],'Screen')
			Case 'ScreenA_Down'
				_RelayScreen(2,$aMcrCmd[1],'Screen')
			Case 'ScreenB_Up'
				_RelayScreen(3,$aMcrCmd[1],'Screen')
			Case 'ScreenB_Down'
				_RelayScreen(4,$aMcrCmd[1],'Screen')
			case 'PowerOther'
				IF $aMcrCmd[2] = 'ON' Then
					_RelayOpen(1,'Power')
				ElseIf $aMcrCmd[2] = 'OFF' Then
					_RelayClose(1,'Power')
				EndIf
				$gV_CamStatus = "Power Other " & $aMcrCmd[2]
				$g_bStatus = True
			case 'PowerAmp'
				IF $aMcrCmd[2] = 'ON' Then
					_RelayOpen(2,'Power')
				ElseIf $aMcrCmd[2] = 'OFF' Then
					_RelayClose(2,'Power')
				EndIf
				$gV_CamStatus = "Power Audio Amps " & $aMcrCmd[2]
				$g_bStatus = True
		EndSwitch
	WEnd

	;----------------------------
	;-- Update onscreen status --
	;----------------------------
	IF $gV_bWait AND NOT ($gP_bZmMode OR $gP_bPanMode OR $gG_bJoyMode) Then								;If just waiting for Command Complete no active PAN TILTL ZOOM Mode
		$gV_CamStatus = ''																				;Clear the Camera Status that indicates PAn TILT ZOOM Mode
	EndIf
	IF $g_bStatus Then
		$Mess = $gV_CamStatus & ' ' & $gV_PanLbl  & ' ' & $gV_TltLbl  & ' ' &  $gV_ZoomLbl
		IF $gV_bWait Then
			$Mess = $Mess & ' Wait Command Complete'
		EndIf
		GUICtrlSetData($hStatusFull,$Mess)
		$g_bStatus = False
	EndIf

	;-----------------------------
	;-- Update GUI Preset Lists --
	;-----------------------------
	IF $iPrstUpdate > -2 Then
		IF StringInStr($g_Debug,"l") Then _ArrayDisplay($aPrst)										;display Preset Array in Array display dialog
		Local $List = _ArrayToString($aPrst,'',-1,-1,'|',0,0)										;Build Preset List into pipe seperated list
		GUICtrlSetData($hPresets,'')																;Clearing the list and then repopulating it insures
		GUICtrlSetData($hPresets,$List)																;displayed names are in same order as array rows
		IF $iPrstUpdate >= 0 Then
			_GUICtrlListBox_SetCurSel($hPresets,$iPrstUpdate)										;Select specified item
		EndIf
		$iPrstUpdate = -2																			;Done don't do again till required
	EndIf

	;---------------------------
	;-- Update GUI Macro List --
	;---------------------------
	IF $iMcrUpdate > -2 Then
		IF StringInStr($g_Debug,"n") Then _ArrayDisplay($aMcrStored)								;display Macro Array in Array display dialog
		Local $List = _ArrayToString($aMcrStored,'',-1,-1,'|',0,0)									;Build Macro List into pipe seperated list
		GUICtrlSetData($hMacros,'')																	;Clearing the list and then repopulating it insures
		GUICtrlSetData($hMacros,$List)																;displayed names are in same order as array rows
		IF $iMcrUpdate >= 0 Then
			_GUICtrlListBox_SetCurSel($hMacros,$iMcrUpdate)											;Select specified item
		EndIf
		$iMcrUpdate = -2																			;Done don't do again till required
	EndIf

	Sleep($iSleep) 																					; Sleep to reduce CPU usage
WEnd

;-----------------------
;-- Support Functions --
;-----------------------

; #FUNCTION# ====================================================================================================================
; Description:		Closes COM Ports DLL handles and TCP processing at exit
; Parameters:		None
; Returns:			Nothing
; Author(s)			Paul verboom (pboom)
; ===============================================================================================================================
Func OnAutoItExit()
	DllClose($gP_hUserDLL)
	_CommSwitch(1)																		;Close COM port for camera
	_Commcloseport(true)
	_CommSwitch(2)																		;Close COM port 4X4 switch
	_Commcloseport(true)
	_CommSwitch(3)																		;Close COM port 6X6 switch
	_Commcloseport(true)
	_GameEnd()																			;Close GamePad handles for good manners
	_RelayCloseAll('Screen')															;Turn Off all relays for Screen control
	DllClose($gR_hDllRelay)																;Close DLL used to control Relay
	TCPShutdown()																		;Close TCP services used by Web Server
EndFunc   ;==>OnAutoItExit


; #FUNCTION# ====================================================================================================================
; Description:		Gets a unique name for Preset or Macro
; Parameters:		$aArray		- Array to check to for unique name checks 1st element 2nd deminision
; Returns:			$Name
;					@error = 1 if no name returned
; Author(s)			Paul verboom (pboom)
; ===============================================================================================================================
Func _GetName($aArray, $Prompt)
	Local $Name = InputBox($g_Title, $Prompt & @LF &'(TimeOut in 20 seconds)', "", " 16",32,145,Default,Default,20,$hForm)
	IF @error Then Return SetError(1)
	$Name = StringReplace($Name,"|","")																;Remove illegal characters from name
	$Name = StringReplace($Name,"~","")
	$Name = StringReplace($Name,",","")
	Local $NameOrg = $Name																			;If name already exist add a incremented suffix
	Local $iSuffix = 0																				;Corrections are done automatically so
	WHILE _ArraySearch($aArray,$Name,0,0,0,0,1,0) <> -1												;operation is not interrupted by dialogs
		$iSuffix += 1																				;Add Incremented suffix to base name
		$Name = $NameOrg & StringFormat('_%02d',$iSuffix)											;This becomes new name to return and test
	WEnd
	IF $iSuffix > 99 Then Return SetError(1)														;Greater than 99 suffixes used then give up.
	Return $Name
EndFunc

;-------------------------------------
;-- Detect Double click in List Box --
;-------------------------------------
Func WM_COMMAND($hWnd, $iMsg, $wParam, $lParam)
	#forceref $hWnd, $iMsg
	Local $hWndFrom, $iIDFrom, $iCode, $hWndListBox, $hWndListBox2
	If Not IsHWnd($hPresets) Then $hWndListBox = GUICtrlGetHandle($hPresets)
	If Not IsHWnd($hMacros) Then $hWndListBox2 = GUICtrlGetHandle($hMacros)
	$hWndFrom = $lParam
	$iIDFrom = BitAND($wParam, 0xFFFF) ; Low Word
	$iCode = BitShift($wParam, 16) ; Hi Word

	Switch $hWndFrom
		Case $hPresets, $hWndListBox
			Switch $iCode
				Case $LBN_DBLCLK ; Sent when the user double-clicks a string in a list box
					IF $iCode = 2 Then $bPresetDublClck = True
			EndSwitch
		Case $hMacros, $hWndListBox2
			Switch $iCode
				Case $LBN_DBLCLK ; Sent when the user double-clicks a string in a list box
					IF $iCode = 2 Then $bMacroDublClck = True
			EndSwitch
	EndSwitch
	; Proceed the default AutoIt3 internal message commands.
	; You also can complete let the line out.
	; !!! But only 'Return' (without any value) will not proceed
	; the default AutoIt3-message in the future !!!
	Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_COMMAND

;----------------------------
;-- Save Presets & Macros  --
;----------------------------
Func _SaveSettings($bPromptName = False)
	Local $FileName = IniRead($g_Config,'Settings','FileName','')										;get the curret default FileName if any
	Local $sDrive = "", $sDir = "", $sFile = "", $sExtension = ""									;Split FileName into its parts
	Local $aPathSplit = _PathSplit($FileName, $sDrive, $sDir, $sFile, $sExtension)
	$Path = $sDrive & $sDir																			;If the FileName parts are blank set defaults
	IF Stringlen($Path) = 0 Then																	;and prompt for the FileName
		$Path = @DocumentsCommonDir
		$bPromptName = True
	EndIf
	IF Stringlen($sFile) = 0 Then
		$sFile = "ControlSettings"
		$bPromptName = True
	EndIf
	IF $bPromptName Then 																			;Prompt for file Name
		Local $Mess = 'Save Presets and Macros to File'
		$FileName = FileOpenDialog($Mess, $Path, "TXT (*.txt)", $FD_PATHMUSTEXIST,$sFile)
		If @error Then Return False																	;If user cancels just abort Save
		IF FileExists($FileName) Then																;verify Overwrite is desired
			IF MsgBox($MB_YESNO,$g_Title,"Replace File",10) <> $IDYES Then Return
		EndIf
	EndIf
	Local $hFileOpen = FileOpen($FileName, $FO_OVERWRITE)											;Open file verify it opens
	If $hFileOpen = -1 Then
		MsgBox($MB_SYSTEMMODAL, "", "An error occurred when opening the file.")
		Return False
	EndIf
	$aPrstAll[$iCam-1] = $aPrst																		;Place presets for current camera back into array of arrays
	FileWriteLine($hFileOpen,"~~Control~~")															;Write a unique header in the file
	For $ic = 1 to 7																				;Write out settings for each Camera in it's own section
		FileWriteLine($hFileOpen,"~Camera|" & $ic)
		$aPrst = $aPrstAll[$ic-1]																	;Now write out presets for that camera
		For $ip = 0 to UBound($aPrst,1) - 1
			FileWriteLine($hFileOpen,"~Preset|" & $ip)												;Write marker for that preset
			FileWriteLine($hFileOpen,$aPrst[$ip][0])												;Write Preset name
			FileWriteLine($hFileOpen,$aPrst[$ip][1])												;Write prest values that are PIPE delimited
;			Local $Line = ''																		;Build line that contains all settings for individual preset
;			FOR $iq = 0 to UBound($aPrst,2) - 1
;				IF StringLen($Line) > 0 Then $Line = $Line & ','
;				$Line = $line & $aPrst[$ip][$iq]
;			Next
;			FileWriteLine($hFileOpen,$Line)
		Next
	Next
	For $im = 0 to UBound($aMcrStored) -1
		FileWriteLine($hFileOpen,"~Macro|" & $im)
		FileWriteLine($hFileOpen,$aMcrStored[$im][0])
		FileWriteLine($hFileOpen,$aMcrStored[$im][1])
	Next
	FileClose($hFileOpen)
	IniWrite($g_Config,'Settings','FileName',$FileName)												;Make this the default settings file
	GUICtrlSetData($hFileName,$FileName)															;Update on screen display of Settings File Name
	$aPrst = $aPrstAll[$iCam-1]																		;Restore presets for selected camera
EndFunc		;==>_SaveSettings

;---------------------------
;-- Load Presets & Macros --
;---------------------------
Func _LoadSettings($bPromptName)
	Local $FileName = IniRead($g_Config,'Settings','FileName','')									;get the curret default FileName if any
	Local $sDrive = "", $sDir = "", $sFile = "", $sExtension = ""									;Split FileName into its parts
	Local $aPathSplit = _PathSplit($FileName, $sDrive, $sDir, $sFile, $sExtension)
	$Path = $sDrive & $sDir
	IF $bPromptName Then 																			;Prompt for file Name if that option is selected
		Local $Mess = 'Load Presets and Macros from File'
		$FileName = FileOpenDialog($Mess, $Path, "TXT (*.txt)", BitOR($FD_PATHMUSTEXIST,$FD_FILEMUSTEXIST) ,$sFile)
		If @error Then Return																		;If user cancels just abort Load
	EndIf

	Global $aPrstAll[7]																				;Clear all presets
	Global $aPrst[0][2]																				;Global so accessable everywhere
	FOR $n = 0 to 6
		$aPrstAll[$n] = $aPrst
	Next
	Local $hFileOpen = FileOpen($FileName, $FO_READ)												;Open the file
    If $hFileOpen = -1 Then
        MsgBox($MB_SYSTEMMODAL, $g_Title, "Unable to open Settings File: " & @CRLF & $FileName)
        Return False
    EndIf
	Local $Line = FileReadLine($hFileOpen, 1)														;Look for signature
	IF $Line <> "~~Control~~" Then
        MsgBox($MB_SYSTEMMODAL, $g_Title, "NOT a valid Settings file.")
        Return False
    EndIf

	Local $Mode = 0																					;indicates what is being read
																									;0 = nothing
																									;1 = camera number sepecified - waiting for preset marker
																									;2 = preset number specified - waiting for preset name
																									;3 = preset name gathered - waiting for preset value
																									;4 = preset values gathered - waiting for next marker
																									;5 = macro number specified  - waiting for macro name
																									;6 = macro name specified - waiting for first line Macro contents
																									;7 = macro contents started - waiting for additional macro contents
	Local $iCamRead = 0																				;Camera Presets are being read for
	Local $Name = ''																				;Name of what is being defined
	Local $Value = ''																				;Value of what is being defined
	Local $Line = ''																				;Line read from file
	Local $aMarker[2] 																				;Marker line split into parts
	Local $bRecord = False																			;Flag add to array any values gathered
	Local $bDone = False																			;Flag reading file done one more pass through loop to add to arays

	WHILE True
		$Line = FileReadLine($hFileOpen)															;Read through file
		IF @error = 1 Then
			MsgBox($MB_SYSTEMMODAL, $g_Title, "Error reading settings file." & @CRLF & $FileName)
			Return False
		EndIf
		IF @error = -1 Then 																		;-1 indicates end of file
			$bRecord = True																			;Commit to arrays any values being gathered
			$bDone = True																			;Last pass through loop
		ElseIf StringLen($Line) = 0 Then															;If NOT END of file and empty line
			ContinueLoop																			;get the next line
		EndIf
		IF StringLeft($Line,1) = '~' Then															;Is this line a Marker
			$aMarker = StringSplit($Line,'|')														;Split in two parts
			IF $aMarker[0] <> 2 THEN ContinueLoop													;Not two parts skip this line
			$bRecord = True
		Else
			$aMarker[1] = ''																		;Clear any previous Markers
		EndIf
		If $bRecord then
			IF $Mode = 4 Then																		;we have a preset defined
				_ArrayAdd($aPrst,$Value,1,'~','~', $ARRAYFILL_FORCE_SINGLEITEM)						;Add Prest values as a single item
				$aPrst[UBound($aPrst)-1][0] = $Name													;Add the Macro Name Name
				$aPrstAll[$iCamRead-1] = $aPrst														;Update Master array of Presets
				$Mode = 1
			EndIf
			IF $Mode = 7 Then																		;We have a macro defined save it
				_ArrayAdd($aMcrStored,$Value,1,'~','~', $ARRAYFILL_FORCE_SINGLEITEM)				;Add Prest values as a single item
				$aMcrStored[UBound($aMcrStored)-1][0] = $Name										;Add the Macro Name Name
				$Mode = 0
			EndIf
			$bRecord = False																		;Only do this once
		EndIf
		IF $bDone = True Then
			ExitLoop
		EndIf
		IF $Mode = 3 Then																			;Waiting for preset values
			$Value = $Line																			;now we have prest values
			$Mode = 4																				;Mode is now preset done, any further lines are ignored
		EndIf
		IF $Mode = 2 Then																			;Waiting for preset name
			$Name = $Line																			;now we have preset name
			$Mode = 3																				;now wait for preset value
		EndIf
		IF $Mode = 1 AND $aMarker[1] = '~preset' Then												;Waiting for a preset marker
			$Mode = 2																				;we have seen preset marke rnow wait for preset name
		EndIf
		IF $aMarker[1] = '~camera' Then																;Define a new camera
			IF $aMarker[2] >= 1 AND $aMarker[2] <= 7 Then											;Verify camera number specified is valid
				$iCamRead = $aMarker[2]																;set camera number prest is being defined for
				$Mode = 1																			;set mode waiting for preset marker
				Redim $aPrst[0][2]																	;Reset current Presets so they don't accumulate
			EndIf
		EndIf
		IF $Mode = 7 Then																			;Waiting for aditional Macro contents
			$Value = $Value & @CRLF & $Line															;Add to Macro contents
			$Mode = 7																				;Stay in this mode waiting for any more
		EndIf
		IF $Mode = 6 Then																			;Waiting first line Macro contents
			$Value = $Line																			;We get first line
			$Mode = 7																				;Now wait for subsiquient lines
		EndIf
		IF $Mode = 5 Then																			;Waiting for Macro Name
			$Name = $Line																			;Get Macro Name
			$Mode = 6																				;Now wait for first line Macro contents
		EndIf
		IF 	$aMarker[1] = '~macro' Then																;Macro marker specified
			$Mode = 5																				;Now wait for macro name
		EndIf
	WEnd

	$aPrst = $aPrstAll[$iCam - 1]																	;recall presets for currently selected camera
	IniWrite($g_Config,'Settings','FileName',$FileName)												;change filename to be loaded next time
	GUICtrlSetData($hFileName,$FileName)															;Update on screen display of Settings File Name
	Return True																						;everything worked returned True
EndFunc ;==>_LoadSettings

;-----------------------
;-- Verify file exist --
;-----------------------
Func _VerifyFile($File,$Descript)
	IF NOT FileExists($File) Then
		Local $Mess = "(71) Unable to locate " & $Descript  & ":" & @CRLF _
			& $File & @CRLF _
			& "Unable to continue." & @CRLF _
			& "Please reinstall this application."
		MsgBox(0+16,$g_Title,$Mess)
		Exit
	EndIf
EndFunc 	;==>_VerifyFile

;------------------------------
;-- Debug a line if flag set --
;------------------------------
Func _DebugMess($Flag,$Mess)
	IF StringInStr($g_Debug,$Flag) Then
		ConsoleWrite($Mess & @LF)
	EndIf
EndFunc		;==>_DebugMess


;---------------------
;-- Open RS232 Port --
;---------------------
#cs
COM Port functionality provided by CommMG.au3 & CommMG.dll writen by martin
https://www.autoitscript.com/forum/topic/128546-serial-port-com-port-udf/?tab=comments#comment-341916
Also see following post that answers many questions
https://www.autoitscript.com/forum/topic/128546-serial-port-com-port-udf/page/29/?tab=comments#comment-1130587
64 bit version of DLL is only required if compilling 64 bit AutoIt EXE.
32 bit version of DLL works fine in 64 bit windows as long as AutoIt is compiled to 32 bit.
#ce
Func _PortOpen($Section)
	Dim $aBaud[25] = ["10400","110","115200","1200","128000","14400","150","15625","1800","19200","2000","2400","256000","28800","38400","3600","38400","4800","50","56000","57600","600","7200","75","9600"]
	Dim $aFlow[3] = ["Hardware", "XOnXoff", "None"]
	Dim $aParity[5] = ["none","odd", "even", "Mark", "Space"]
	Local $Mess = ""																					;Build any errors into this Message

	$Port = IniRead($g_Config,$Section,"Port","")														;COM Port must be specified
	$Port = StringReplace($Port,"COM","")
	Local $nPort = Number($Port)
	IF  $nPort < 1 OR $nPort > 255 Then
		$Mess = $Mess & "Invalid COM Port Number specified: " & $nPort & @CRLF
	EndIf

	$nBaud = -1																							;Baud Rate default is 9600
	$Baud = IniRead($g_Config,$Section,"Baud","9600")
	For $n = 0 To ubound($aBaud)
		If $Baud = $aBaud[$n] Then
			$nBaud = $aBaud[$n]
			ExitLoop
		EndIf
	Next
	IF $nBaud = -1 Then
		$Mess = $Mess & "Invalid Baud Rate specified: " & $Baud & @CRLF
	EndIf

	$nDataBits = 0 + IniRead($g_Config,$Section,"DataBits",8)
	IF $nDataBits < 7 OR $nDataBits > 8 Then
		$Mess = $Mess & "Invalid Data Bits specified: " & $nDataBits & @CRLF
	EndIf

	$nParity = -1
	$parity = IniRead($g_Config,$Section,"Parity","None")
	For $n = 0 To ubound($aParity)
		If $Parity = $aParity[$n] Then
			$nparity = $n
			ExitLoop
		EndIf
	Next
	IF $nParity = -1 Then
		$Mess = $Mess & "Invalid Parity specified: " & $Parity & @CRLF
	EndIf

	$Stop = 0 + IniRead($g_Config,$Section,"Stop",1)
    $Stop = StringReplace($Stop, '.', '')															;replace 1.5 with 15 if needed
	IF $Stop <> 1 AND $Stop <> 15 AND $Stop <> 2 Then
		$Mess = $Mess & "Invalid Stop Bits specified: " & $Stop & @CRLF
	EndIf

	$nFlow = -1
	$Flow = IniRead($g_Config,$Section,"Flow","None")
	For $n = 0 To ubound($aFlow)
		If $Flow = $aFlow[$n] Then
			$nFlow = $n
			ExitLoop
		EndIf
	Next
	IF $nFlow = -1 Then
		$Mess = $Mess & "Invalid Flow Control specified: " & $Flow & @CRLF
	EndIf

	IF StringLen($Mess) > 0	Then																		;Any error just about											;
		$Mess = "Error in setting for RS232 port for: " & $Section & @CRLF & $Mess
		MsgBox($MB_ICONERROR,$g_Title,$Mess)
		Exit
	EndIf

	Local $portSetError																					;Holds any error opening port
	$resOpen = _CommSetPort($Port, $portSetError, $nBaud, $nDataBits, $nParity, $Stop, $nflow)
	If $resOpen = 0 then
		$Mess = "Error in opening RS232 port for: " & $Section & @CRLF & $portSetError
		MsgBox($MB_ICONERROR,$g_Title,$Mess)															;Display Error opening COM
		IF StringInStr($g_Debug,"2") Then Exit															;Only abort on RS232 open errors
	EndIf																								;if that flag is selected

	Sleep(100)
	_DebugMess("o","RS232 port opened for: " & $Section)
EndFunc		;==>_PortOpen

;--------------------------
;-- Add Command to macro --
;--------------------------
Func _McrCmdAdd($Cmd)
	IF UBOUND($aMacro) = 0 Then
		_ArrayAdd($aMacro,$Cmd,0,'~')
	Else
		_ArrayInsert($aMacro,0,$Cmd,0,'~')
	EndIf
EndFunc		;==>_McrCmdAdd
